ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.6 by root, Sun Mar 11 02:12:45 2007 UTC vs.
Revision 1.100 by root, Wed Oct 6 03:44:55 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hash collision, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161our @WALL_SUFFIX = qw(⬤ ╹ ╺ ┗ ╻ ┃ ┏ ┣ ╸ ┛ ━ ┻ ┓ ┫ ┳ ╋);
162
163# used to create crude text glyphs for text-based clients
164sub autoglyph {
165 my ($stem, $face) = @_;
166
167 if ($stem =~ /^wall\/|Nimwall/) {
168 return $WALL_SUFFIX[hex $1]
169 if $stem =~ /(_[0-9A-F]).x11/;
170
171 "█"
172
173 } elsif ($stem =~ /^traps\//) {
174 "☠"
175
176 } elsif ($stem =~ /^armour\/shield/) {
177 "Ø"
178
179 } elsif ($stem =~ /^armour\//) {
180 "A"
181
182 } elsif ($stem =~ /^weapon\//) {
183 "†"
184
185 } elsif ($stem =~ /^readable\//) {
186 "✉"
187
188 } elsif ($stem =~ /^river\//) {
189 "~"
190
191 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
192 "·"
193
194 } elsif ($stem =~ /^spells\//) {
195 "!"
196
197 } elsif ($stem =~ /^player\//) {
198 "\@"
199
200 } elsif ($stem =~ /^(?:monster|misc|class|connect|gods|indoor|inorganic|mining|music|skills).*\/(.)/) {
201 $1
202
203 } else {
204 substr $stem, 0, 1
205 }
206}
207
82{ 208{
83 our %PNG32; 209 our %ANIMINFO;
84 our %FACEINFO; 210 our %FACEINFO;
211 our %RESOURCE;
85 our @ARC; 212 our @ARC;
213 our %ARC;
214 our $TRS;
86 our $NFILE; 215 our $NFILE;
87 our %ANIM; 216 our $PATH;
88 217
89 our (@png, @trs, @arc); # files we are interested in 218 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 219
220 our $c_arc = new Coro::Channel;
221 our $c_trs = new Coro::Channel;
222 our $c_res = new Coro::Channel;
223
224 our @c_png;
225
91 sub commit_png { 226 sub commit_png($$$$) {
92 my ($name, $data) = @_; 227 my ($stem, $name, $data, $T) = @_;
93 228
94 $PNG32{$name} = $data; 229 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 230 $FACEINFO{$name}{"data$T"} = $data;
96 } 231 }
97 232
98 sub process_png { 233 sub process_png {
99 while (@png) { 234 while (@c_png) {
100 my $path = pop @png; 235 my ($path, $delete) = @{pop @c_png};
101 236
102 my $png; 237 my $png;
103 aio_lstat $path; 238 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 239 my ($size, $mtime) = (stat _)[7,9];
105 240
106 if (0 > aio_load $path, $png) { 241 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 242 warn "$path: $!, skipping.\n";
108 next; 243 next;
109 } 244 }
110 245
246 my $stem = $path;
247 my $T;
248
249 if ($stem =~ s/\.32x32\.png~?$//) {
250 $T = 32;
251 } elsif ($stem =~ s/\.64x64\.png~?$//) {
252 $T = 64;
253 } else {
254 warn "$path: weird filename, skipping.\n";
255 next;
256 }
257
111 # quickly extract width and height of the (necessarily PNG) image 258 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 259 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 260 warn "$path: not a recognized png file, skipping.\n";
114 next; 261 next;
115 } 262 }
116 263
117 my ($w, $h) = unpack "NN", $1; 264 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 265
127 if ($w < $T || $h < $T) { 266 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 267 warn "$path: too small ($w $h), skipping.\n";
129 next; 268 next;
130 } 269 }
132 if ($w % $T || $h % $T) { 271 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 272 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 273 next;
135 } 274 }
136 275
276 (my $base = $stem) =~ s/^.*\///;
277
278 my $fi = $FACEINFO{$base};
279 unless ($fi) {
280 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
281 #next;
282 }
283
284 my $arc = $fi->{arc} || { };
285
286 unless ($path =~ /~$/) {
287 # possibly enlarge
288 if (0 > aio_stat "$stem.64x64.png") {
289 my $other = "$stem.64x64.png~";
290
291 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
292 fork_sub {
293 my $CROP;
294 my $SRC = "png:\Q$path\E";
295
296 my $is_floor = $arc->{is_floor};
297 my $is_wall = 0;
298
299 my ($wall_pfx, $wall_dir, $wall_sfx);
300
301 if (
302 !$is_floor
303 && !$arc->{alive}
304 && $arc->{move_block} eq "all"
305 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
306 ) {
307 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
308
309 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
310 $is_wall = 1;
311 }
312 }
313
314 if ($is_wall || $is_floor) {
315 # add a 4px border and add other images around it
316 $CROP = "-shave 8x8 +repage";
317
318 $w += 8;
319 $h += 8;
320
321 $SRC = "-size ${w}x${h} xc:transparent";
322 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
323
324 # 8 surrounding images
325 for (
326 # x y b r0 r1
327 [-1, -1, 0, 6],
328 [ 0, -1, 1, 10, 14],
329 [+1, -1, 0, 12],
330
331 [-1, 0, 8, 5, 7],
332 #
333 [+1, 0, 2, 5, 13],
334
335 [-1, +1, 0, 3],
336 [ 0, +1, 4, 10, 11],
337 [+1, +1, 0, 9],
338 ) {
339 my ($x, $y, $d, $r0, $r1) = @$_;
340
341 my $tile = $is_floor ? $path
342 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
343 : die;
344
345 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
346 "\Q$tile",
347 $x * ($w - 8) + 4,
348 $y * ($h - 8) + 4;
349 }
350 }
351
352 system "convert -depth 8 $SRC rgba:-"
353 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
354 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
355 and die "convert/cfhq2xa pipeline error: status $? ($!)";
356 system $OPTIPNG, "-i0", "-q", "$other~";
357 die "$other~ has zero size, aborting." unless -s "$other~";
358 rename "$other~", $other;
359 };
360 }
361
362 push @c_png, [$other, !$CACHE];
363 }
364
365 # possibly scale down
366 if (0 > aio_stat "$stem.32x32.png") {
367 my $other = "$stem.32x32.png~";
368
369 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
370 fork_sub {
371 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
372 system $OPTIPNG, "-i0", "-q", "$other~";
373
374 # reduce smoothfaces >10000 bytes
375 # obsolete, no longer required
376 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
377 my $ncolor = 256;
378 while () {
379 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
380 system $OPTIPNG, "-i0", "-q", "$other~~";
381 last if 10000 > -s "$other~~";
382 $ncolor = int $ncolor * 0.9;
383 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
384 }
385
386 printf "reduced %s from %d to %d bytes using %d colours.\n",
387 $other, -s "$other~", -s "$other~~", $ncolor
388 if $VERBOSE >= 2;
389 rename "$other~~", "$other~";
390 }
391
392 die "$other~ has zero size, aborting." unless -s "$other~";
393 rename "$other~", $other;
394 };
395 }
396
397 #warn "scaled down $path to $other\n";#d#
398 push @c_png, [$other, !$CACHE];
399 }
400 }
401
402 (my $face = $stem) =~ s/^.*\///;
403
404 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 405 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 406 # split
139 my @tile; 407 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 408 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 409 for my $y (0 .. (int $h / $T) - 1) {
154 (map { 422 (map {
155 ( 423 (
156 "(", 424 "(",
157 "+clone", 425 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 426 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
427 "+repage",
428 -quality => "00",
159 -write => "png:$_->[2]~", 429 -write => "png32:$_->[2]~",
160 "+delete", 430 "+delete",
161 ")", 431 ")",
162 ) 432 )
163 } @todo), 433 } @todo),
164 "null:"; 434 "null:";
168 close $convert; 438 close $convert;
169 439
170 # pass 2, optimise, and rename 440 # pass 2, optimise, and rename
171 for (@todo) { 441 for (@todo) {
172 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 442 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
443 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
173 rename "$_->[2]~", $_->[2]; 444 rename "$_->[2]~", $_->[2];
174 } 445 }
175 }; 446 };
176 } 447 }
177 448
181 452
182 if (0 > aio_load $file, $tile) { 453 if (0 > aio_load $file, $tile) {
183 die "$path: unable to read tile +$x+$y, aborting.\n"; 454 die "$path: unable to read tile +$x+$y, aborting.\n";
184 } 455 }
185 IO::AIO::aio_unlink $file unless $CACHE; 456 IO::AIO::aio_unlink $file unless $CACHE;
186 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 457 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
187 } 458 }
188 } else { 459 } else {
189 # use as-is (either small, use smooth) 460 # use as-is (either small, use smooth)
190 commit_png $face, $png; 461 commit_png $stem, $face, $png, $T;
191 } 462 }
463
464 aio_unlink $path if $delete;
192 } 465 }
193 } 466 }
194 467
195 sub process_arc { 468 sub process_arc {
196 while (@arc) { 469 while (my $job = $c_arc->get) {
197 my ($dir, $file) = @{pop @arc}; 470 my ($dir, $file) = @$job;
198 471
199 my $arc; 472 my $arc;
200 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 473 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
201 474
202 my $arc = read_arch "$dir/$file"; 475 my $arc = read_arch "$dir/$file";
203 for my $o (values %$arc) { 476 for my $o (values %$arc) {
204 push @ARC, $o; 477 push @ARC, $o;
478 for (my $m = $o; $m; $m = $m->{more}) {
479 $ARC{$m->{_name}} = $m;
480 }
481
482 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
205 483
206 my $visibility = delete $o->{visibility}; 484 my $visibility = delete $o->{visibility};
207 my $magicmap = delete $o->{magicmap}; 485 my $magicmap = delete $o->{magicmap};
486 my $glyph = delete $o->{glyph};
208 487
209 # find upper left corner :/ 488 # find upper left corner :/
210 # omg, this is sooo broken 489 # omg, this is sooo broken
211 my ($dx, $dy); 490 my ($dx, $dy);
212 for (my $o = $o; $o; $o = $o->{more}) { 491 for (my $o = $o; $o; $o = $o->{more}) {
218 my $x = $o->{x} - $dx; 497 my $x = $o->{x} - $dx;
219 my $y = $o->{y} - $dy; 498 my $y = $o->{y} - $dy;
220 499
221 my $ext = $x|$y ? "+$x+$y" : ""; 500 my $ext = $x|$y ? "+$x+$y" : "";
222 501
223 $o->{face} .= $ext; 502 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
224 503
225 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 504 $visibility = delete $o->{visibility} if exists $o->{visibility};
226 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 505 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
506 $glyph = delete $o->{glyph} if exists $o->{glyph};
227 507
228 my $anim = delete $o->{anim}; 508 my $anim = delete $o->{anim};
229 509
230 if ($anim) { 510 if ($anim) {
511 # possibly add $ext to the animation name to avoid
512 # the need to specify archnames for all parts
513 # of a multipart archetype.
231 $o->{animation} = "$o->{_name}$ext"; 514 $o->{animation} = "$o->{_name}";
515 my $facings = 1;
516 my @frames;
232 517
233 for (@$anim) { 518 for (@$anim) {
234 $_ .= $ext unless /^facings\s/; 519 if (/^facings\s+(\d+)/) {
520 $facings = $1*1;
521 } elsif (/^blank.x11$|^empty.x11$/) {
522 push @frames, $_;
523 } else {
524 push @frames, "$_$ext";
525 }
235 } 526 }
236 527
237 $ANIM{"$o->{_name}$ext"} = 528 $ANIMINFO{$o->{animation}} = {
238 join "", map "$_\n", 529 facings => $facings,
239 "anim $o->{_name}$ext", 530 frames => \@frames,
240 @$anim, 531 };
241 "mina";
242 } 532 }
243 533
244 for my $face ($o->{face} || (), @{$anim || []}) { 534 for ($o->{face} || (), @{$anim || []}) {
245 next if /^facings\s/; 535 next if /^facings\s/;
246 536
537 my $face = $_;
538 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
539
247 my $info = $FACEINFO{$face} ||= {}; 540 my $info = $FACEINFO{$face} ||= { };
541 $info->{arc} = $o;
542
543 next if $face =~ /^blank.x11$|^empty.x11$/;
248 544
249 $info->{visibility} = $visibility if defined $visibility; 545 $info->{visibility} = $visibility if defined $visibility;
250 $info->{magicmap} = $magicmap if defined $magicmap; 546 $info->{magicmap} = $magicmap if defined $magicmap;
547 $info->{glyph} = $glyph if defined $glyph;
251 } 548 }
549
550 if (my $smooth = delete $o->{smoothface}) {
551 my %kv = split /\s+/, $smooth;
552 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
553 while (my ($face, $smooth) = each %kv) {
554 $FACEINFO{$smooth}{arc} = $o;
555
556 $FACEINFO{$face}{smooth} = $smooth;
557 $FACEINFO{$face}{smoothlevel} = $level;
558 }
559 }
252 } 560 }
253 } 561 }
254 } 562 }
255 } 563 }
256 564
257 sub process_trs { 565 sub process_trs {
258 while (@trs) { 566 while (my $job = $c_trs->get) {
259 my ($dir, $file) = @{pop @trs}; 567 my ($dir, $file) = @$job;
568 my $path = "$dir/$file";
569
570 my $trs;
571 if (0 > aio_load $path, $trs) {
572 warn "$path: $!, skipping.\n";
573 next;
574 }
575
576 $TRS .= $trs;
577 }
578 }
579
580 my %FILECACHE;
581
582 sub load_cached($;$) {
583 unless (exists $FILECACHE{$_[0]}) {
584 my $data;
585 if (0 < aio_load $_[0], $data) {
586 if ($_[1]) {
587 $data = eval { $_[1]->($data) };
588 warn "$_[0]: $@" if $@;
589 }
590 }
591
592 $FILECACHE{$_[0]} = $data;
593 }
594
595 $FILECACHE{$_[0]}
596 }
597
598 sub process_res {
599 while (my $job = $c_res->get) {
600 my ($dir, $file, $type) = @$job;
601
602 my $data;
603 aio_load "$dir/$file", $data;
604
605 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
606
607 utf8::decode $dir;
608 utf8::decode $file;
609
610 # a meta file for resources is now mandatory
611 unless (exists $meta->{$file}) {
612 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
613 next;
614 }
615
616 $meta = {
617 %{ $meta->{"" } || {} },
618 %{ $meta->{$file} || {} },
619 };
620
621 if ($meta->{license} =~ s/^#//) {
622 $meta->{license} = ({
623 "pd" => "Public Domain",
624 "gpl" => "GNU General Public License, version 3.0 or any later",
625 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
626 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
627 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
628 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
629 })->{$meta->{license}}
630 || warn "$dir/$file: license tag '$meta->{license}' not found.";
631 }
632
633 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
634 ($meta->{author} = $1) =~ s/_/ /g;
635 }
636
637 $file =~ s/\.res$//;
638 $file =~ s/\.(ogg|wav|jpg|png)$//;
639
640 substr $dir, 0, 1 + length $PATH, "";
641
642 if (my $filter = $meta->{cfutil_filter}) {
643 if ($filter eq "yaml2json") {
644 $data = JSON::XS::encode_json YAML::XS::Load $data;
645 } elsif ($filter eq "json2json") {
646 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
647 } elsif ($filter eq "perl2json") {
648 $data = eval $data; die if $@;
649 $data = JSON::XS::encode_json $data;
650 } else {
651 warn "$dir/$file: unknown filter $filter, skipping\n";
652 }
653 }
654
655 $RESOURCE{"$dir/$file"} = {
656 type => (exists $meta->{type} ? delete $meta->{type} : $type),
657 data => $data,
658 %$meta ? (meta => $meta) : (),
659 };
260 } 660 }
261 } 661 }
262 662
263 sub find_files; 663 sub find_files;
264 sub find_files { 664 sub find_files {
267 IO::AIO::aioreq_pri 4; 667 IO::AIO::aioreq_pri 4;
268 IO::AIO::aio_scandir $path, 4, sub { 668 IO::AIO::aio_scandir $path, 4, sub {
269 my ($dirs, $nondirs) = @_; 669 my ($dirs, $nondirs) = @_;
270 670
271 find_files "$path/$_" 671 find_files "$path/$_"
272 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 672 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
673
674 my $dir = $path;
675 substr $dir, 0, 1 + length $PATH, "";
273 676
274 for my $file (@$nondirs) { 677 for my $file (@$nondirs) {
678 if ($dir =~ /^music(?:\/|$)/) {
679 $c_res->put ([$path, $file, 3]) # FT_MUSIC
680 if $file =~ /\.(ogg)$/;
681
682 } elsif ($dir =~ /^sound(?:\/|$)/) {
683 $c_res->put ([$path, $file, 5]) # FT_SOUND
684 if $file =~ /\.(wav|ogg)$/;
685
686 } elsif ($dir =~ /^res(?:\/|$)/) {
687 if ($file =~ /\.(jpg|png)$/) {
688 $c_res->put ([$path, $file, 0]) # FT_FACE
689 } elsif ($file =~ /\.(res)$/) {
690 $c_res->put ([$path, $file, 6]) # FT_RSRC
691 } else {
692 $c_res->put ([$path, $file, undef]);
693 }
694
275 if ($file =~ /\.png$/) { 695 } elsif ($file =~ /\.png$/) {
276 push @png, "$path/$file"; 696 push @c_png, ["$path/$file", 0];
697
277 } elsif ($file =~ /\.trs$/) { 698 } elsif ($file =~ /\.trs$/) {
278 push @trs, [$path, $file]; 699 $c_trs->put ([$path, $file]);
700
279 } elsif ($file =~ /\.arc$/) { 701 } elsif ($file =~ /\.arc$/) {
280 push @arc, [$path, $file]; 702 $c_arc->put ([$path, $file]);
703
281 } else { 704 } else {
282 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 705 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
283 } 706 }
284 } 707 }
285 }; 708 };
709 }
710
711 sub generate_plurals {
712# use Lingua::EN::Inflect ();
713# Lingua::EN::Inflect::classical;
714# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
715# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
716#
717# for my $a (@ARC) {
718# my $name = $a->{name} || $a->{_name};
719#
720# next unless $a->{name_pl};
721# next if $a->{invisible};
722# next if $a->{is_floor};
723# next if $a->{no_pick};
724#
725# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
726# my $pl = $test =~ /^(?:eq|p:.)$/
727# ? $name
728# : Lingua::EN::Inflect::PL $name;
729#
730# if ($pl ne $a->{name_pl}) {
731# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
732# }
733# }
286 } 734 }
287 735
288 sub inst_arch($) { 736 sub inst_arch($) {
289 my (undef, $path) = @_; 737 my (undef, $path) = @_;
290 738
739 $PATH = $path;
740
741 print "\n",
291 print "installing '$path' to '$DATADIR'\n\n"; 742 "Installing '$path' to '$DATADIR'\n",
743 "\n",
744 "This can take a long time if you run this\n",
745 "for the first time or do not use --cache.\n",
746 "\n",
747 "Unless you run verbosely, all following warning\n",
748 "or error messages indicate serious problems.\n",
749 "\n";
292 750
293 if (!-d "$path/treasures") { 751 if (!-d "$path/treasures") {
294 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 752 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
295 exit 1 unless $FORCE; 753 exit 1 unless $FORCE;
296 } 754 }
297 755
756 print "scanning files...\n" if $VERBOSE;
757
298 find_files $path; 758 find_files $path;
759
760 my @a_arc = map +(async \&process_arc), 1..2;
761 my @a_res = map +(async \&process_res), 1..2;
762 my @a_trs = map +(async \&process_trs), 1..2;
763
299 IO::AIO::flush; 764 IO::AIO::flush;
300 765
301 $_->join for ( 766 $c_res->shutdown;
302 (async \&process_png), (async \&process_png), 767 $c_arc->shutdown;
303 (async \&process_trs), (async \&process_trs), 768 $c_trs->shutdown;
304 (async \&process_arc), (async \&process_arc),
305 );
306 769
770 print "start file scan, arc, res processing...\n" if $VERBOSE;
771
772 $_->join for @a_arc; # need to parse all archetypes before png processing
773
774 print "end arc, start png processing...\n" if $VERBOSE;
775
776 # eight png crunchers work fine for my 4x smp machine
777 my @a_png = map +(async \&process_png), 1..8;
778
779 $_->join for (@a_trs, @a_res, @a_png);
780
781 print "scanning done, processing results...\n" if $VERBOSE;
307 { 782 {
308 open my $fh, ">:utf8", "$DATADIR/animations~" 783 # remove path prefix from editor_folder
309 or die "$DATADIR/animations~: $!"; 784 $_->{editor_folder} =~ /^\x00/
310 print $fh join "", map $ANIM{$_}, sort keys %ANIM 785 and substr $_->{editor_folder}, 0, 2 + length $path, ""
786 for values %ARC;
787
788 print "resolving inheritance tree...\n" if $VERBOSE;
789 # resolve inherit
790 while () {
791 my $progress;
792 my $loop;
793
794 for my $o (values %ARC) {
795 for my $other (split /,/, $o->{inherit}) {
796 if (my $s = $ARC{$other}) {
797 if ($s->{inherit}) {
798 $loop = $s;
799 } else {
800 delete $o->{inherit};
801 my %s = %$s;
802 delete @s{qw(_name more name name_pl)};
803 %$o = ( %s, %$o );
804 ++$progress;
805 }
806 } else {
807 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
808 delete $ARC{$o->{_name}};
809 }
810 }
811 }
812
813 unless ($progress) {
814 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
815 if $loop;
816
817 last;
818 }
311 } 819 }
312 820
313 { 821 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
822 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
823
824 print "generating plurals...\n" if $VERBOSE;
825 generate_plurals;
826
827 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
314 open my $fh, ">:utf8", "$DATADIR/archetypes~" 828 open my $fh, ">:utf8", "$DATADIR/archetypes~"
315 or die "$DATADIR/archetypes~: $!"; 829 or die "$DATADIR/archetypes~: $!";
316 print $fh Crossfire::archlist_to_string \@ARC; 830 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
317 } 831 }
318 832
319 { 833 {
834 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
835 open my $fh, ">:utf8", "$DATADIR/treasures~"
836 or die "$DATADIR/treasures~: $!";
837 print $fh $TRS;
838 }
839
840 {
841 print "processing facedata...\n" if $VERBOSE;
320 while (my ($k, $v) = each %FACEINFO) { 842 while (my ($k, $v) = each %FACEINFO) {
321 $v->{data32} ||= delete $PNG32{$k}; 843 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
844 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
845
846 make_hash $k, $v->{data32}, $v->{hash32};
847 make_hash $k, $v->{data64}, $v->{hash64};
848
849 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
850 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
851
852 if (my $magicmap = $v->{magicmap}) {
853 $magicmap =~ y/A-Z_\-/a-z/d;
854 $v->{magicmap} = $COLOR{$magicmap};
322 } 855 }
323 856
857 my $stem = delete $v->{stem};
858 $v->{glyph} //= autoglyph $stem, $v;
859 utf8::encode $v->{glyph};
860 $v->{glyph} = (chr $v->{magicmap}) . $v->{glyph};
861
862 delete $v->{arc};
863 }
864
865 print "processing resources...\n" if $VERBOSE;
866 my $enc = JSON::XS->new->utf8->canonical->relaxed;
324 while (my ($k, $v) = each %FACEINFO) { 867 while (my ($k, $v) = each %RESOURCE) {
325 exists $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
326 868
327 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 869 if ($v->{meta} && $v->{meta}{datadir}) {
870 delete $RESOURCE{$k};
871
872 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
873
874 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
875 open my $fh, ">:raw", "$DATADIR/$k~"
876 or die "$DATADIR/$k~: $!";
877 syswrite $fh, $v->{data};
878 push @COMMIT, $k;
879
880 } else {
881 if ($v->{type} & 1) {
882 # prepend meta info
883
884 my $meta = $enc->encode ({
885 name => $k,
886 %{ $v->{meta} || {} },
887 });
888
889 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
890 }
891
892 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
328 } 893 }
894 }
329 895
896 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
897 scalar keys %FACEINFO,
898 scalar keys %ANIMINFO,
899 scalar keys %RESOURCE
900 if $VERBOSE;
901
330 open my $fh, ">:perlio", "$DATADIR/faces~" 902 open my $fh, ">:perlio", "$DATADIR/facedata~"
331 or die "$DATADIR/faces~: $!"; 903 or die "$DATADIR/facedata~: $!";
332 904
333 print $fh Storable::nfreeze \%FACEINFO; 905 print $fh nfreeze {
334 906 version => 2,
335 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 907 faceinfo => \%FACEINFO,
908 animinfo => \%ANIMINFO,
909 resource => \%RESOURCE,
336 } 910 };
337 911
338 for (qw(archetypes faces animations)) { 912 }
913
914 print "committing files...\n" if $VERBOSE;
915
916 for (qw(archetypes facedata treasures), @COMMIT) {
339 chmod 0644, "$DATADIR/$_~"; 917 chmod 0644, "$DATADIR/$_~";
340 rename "$DATADIR/$_~", "$DATADIR/$_"; 918 rename "$DATADIR/$_~", "$DATADIR/$_"
919 or die "$DATADIR/$_: $!";
341 } 920 }
342 921
343 die "--install-arch not fully implemented\n"; 922 print "archetype data installed successfully.\n";
344 } 923 }
345} 924}
346 925
347Getopt::Long::Configure ("bundling", "no_ignore_case"); 926Getopt::Long::Configure ("bundling", "no_ignore_case");
348GetOptions ( 927GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines